//+------------------------------------------------------------------+
//|                                             Autooptimization.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- input parameters
extern int       OptimPeriod=10080; //     PERIOD_W1 - 10080
extern int       EndDate=0;     //      ( )  . 0 -  /
extern int       OptimDuration=43200; //     EndDate,  ,    
extern int       TPStart=30; //     
extern int       TPStep=5;   //     
extern int       TPEnd=30;  //     
extern int       SLStart=30; //     
extern int       SLStep=5;   //     
extern int       SLEnd=30;  //     
extern int       CCIPeriod=21;  //  CCI 
extern double    Lots=0.1;   
extern int       MagicNumber=490;

#include <WinUser32.mqh>

datetime LastOptim;
bool Activate = False, FreeMarginAlert = False;
double Spread;
int TakeProfit = 50, StopLoss = 100, 
   Combination, StopLevel;
int EqualProfit[], TransCount[], MaxDrowDown[];

//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
void Optimization()
{
 int StartBar = iBarShift(Symbol(), 0, TimeCurrent()-60*(EndDate+OptimDuration));
 int EndBar = iBarShift(Symbol(), 0, TimeCurrent()-60*EndDate);
 int Count = 0;
 double CurRF = -999999;
 ArrayInitialize(EqualProfit, 0);
 ArrayInitialize(TransCount, 0);
 ArrayInitialize(MaxDrowDown, 0);
 for(int TP = TPStart; TP <= TPEnd; TP += TPStep)
  for(int SL = SLStart; SL <= SLEnd; SL += SLStep)
   {
    int CurTrans =0;
    double CurOpenPrice = 0;
    int EqualMax = 0;
    int EqualMin = 0;
     for(int i = StartBar; i >= EndBar; i--)
      {
       EqualMin = MathMin(EqualProfit[Count], EqualMin);
       if(EqualProfit[Count] > EqualMax)
        {
         MaxDrowDown[Count] = MathMax(MaxDrowDown[Count], EqualMax-EqualMin);
         EqualMax = EqualProfit[Count];
         EqualMin = EqualMax;
        }
        
       double CCI1 = iCCI(Symbol(), 0, CCIPeriod, PRICE_TYPICAL, i+1);
       double CCI2 = iCCI(Symbol(), 0, CCIPeriod, PRICE_TYPICAL, i+2);
      
       //  Sell
       if(CCI1 < 100 && CCI2 > 100 && CurTrans != 2)
        {
         if(CurTrans == 1)
           EqualProfit[Count] += (Open[i]-CurOpenPrice)/Point;
         // "" 
         CurOpenPrice = Open[i];
         CurTrans = 2;
         TransCount[Count]++;
        }
            
       //  Buy
       if(CCI1 > -100 && CCI2 < -100 && CurTrans != 1)
        {
         if(CurTrans == 2)
           EqualProfit[Count] += (CurOpenPrice-Open[i]-Spread)/Point;
         // "" 
         CurOpenPrice = Open[i]+Spread;
         CurTrans = 1;
         TransCount[Count]++;
        }    
        
       //       Buy
       if(CurTrans == 1)
        {
         if(ND(Low[i]) <= ND(CurOpenPrice-SL*Point))
          {
           EqualProfit[Count] -= SL;
           CurTrans = 0;
           continue;
          }
         if(ND(High[i]) >= ND(CurOpenPrice+TP*Point))
          {
           EqualProfit[Count] += TP;
           CurTrans = 0;
           continue;
          }
        }

       //       Sell
       if(CurTrans == 2)
        {
         if(ND(High[i]) >= ND(CurOpenPrice+SL*Point-Spread))
          {
           EqualProfit[Count] -= SL;
           CurTrans = 0;
           continue;
          }
         if(ND(Low[i]) <= ND(CurOpenPrice-TP*Point-Spread))
          {
           EqualProfit[Count] += TP;
           CurTrans = 0;
           continue;
          }
        }
        
      } //  i
    
    //   
    if(CurTrans == 2)
     EqualProfit[Count] += (CurOpenPrice-Close[i+1]-Spread)/Point;  
    if(CurTrans == 1)
     EqualProfit[Count] += (Close[i+1]-CurOpenPrice)/Point; 

    MaxDrowDown[Count] = MathMax(MaxDrowDown[Count], EqualMax-EqualMin);
    if(EqualProfit[Count] != 0)
     if(CurRF < MaxDrowDown[Count]/EqualProfit[Count])
      {
       CurRF = MaxDrowDown[Count]/EqualProfit[Count];
       int Num = Count;
       int BestSL = SL;
       int BestTP = TP;
      }
     
    Count++;
   } //  SL  TP 
 
   
 Alert(" .  max ", EqualProfit[Num]," .  ", TransCount[Num], ".  ", MaxDrowDown[Num]);
 Alert(": TakeProfit = ", BestTP, ", StopLoss = ", BestSL);
 LastOptim = TimeCurrent();
 GlobalVariableSet("LastOptimization", LastOptim);
 if(CurRF < 0)
  if(MessageBox("   ./n   ?", "", MB_YESNO) == IDNO) 
    return;    
 TakeProfit = BestTP;
 StopLoss = BestSL;
 GlobalVariableSet("AutoProfit", TakeProfit);
 GlobalVariableSet("AutoStop", StopLoss);
}  //  

//+------------------------------------------------------------------+
//|     Digits                            |
//+------------------------------------------------------------------+
double ND(double A)
{
 return(NormalizeDouble(A, Digits));
}

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
   Spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;
   StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL); 

   if(GlobalVariableCheck("LastOptimization"))
     LastOptim = GlobalVariableGet("LastOptimization");
    else
     LastOptim = 0; 

   if(GlobalVariableCheck("AutoProfit"))
     TakeProfit = GlobalVariableGet("AutoProfit");

   if(GlobalVariableCheck("AutoStop"))
     StopLoss = GlobalVariableGet("AutoStop");

   //    
   if(OptimPeriod < Period()*2)
     {
      Print("   OptimPeriod.  !");
      Comment("   OptimPeriod.  !");
      return(0);
     }
   if(EndDate < 0)
     {
      Print("   EndDate.  !");
      Comment("   EndDate.  !");
      return(0);
     }
   if(OptimDuration < Period()*2)
     {
      Print("   OptimDuration.  !");
      Comment("   OptimDuration.  !");
      return(0);
     }
   if(TPStart > TPEnd || SLStart > SLEnd || TPStart <= StopLevel || SLStart <= StopLevel+Spread/Point)
     {
      Print("  TPStart, TPEnd, SLStart  SLEnd.  !");
      Comment("  TPStart, TPEnd, SLStart  SLEnd.  !");
      return(0);
     }
   if(TPStep < 1 || SLStep < 1)
     {
      Print(" TPStep  SLStep     1.  !");
      Comment(" TPStep  SLStep     1.  !");
      return(0);
     }
   // ----------------------------------------
 
   Combination = MathFloor((TPEnd-TPStart)/TPStep)*MathFloor((SLEnd-SLStart)/SLStep);
   ArrayResize(EqualProfit, Combination+1);
   ArrayResize(TransCount, Combination+1);
   ArrayResize(MaxDrowDown, Combination+1);
   
   Activate = True;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//|    (True -  , False -  )      |
//+------------------------------------------------------------------+
bool IsOwnOrder()
{
 for(int i=0; i<OrdersTotal(); i++)
  if(OrderSelect(i, SELECT_BY_POS))
   if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
     return(True);
 return(False);    
}

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OpenOrder(int Type, double Price, double SL, double TP, color Arrow)
{
 //     
 if(AccountFreeMarginCheck(Symbol(), OP_BUY, Lots) <= 0 || GetLastError() == 134)
  {
   if(!FreeMarginAlert)
    {
     Print("    . Free Margin = ", AccountFreeMargin());
     FreeMarginAlert = True;
    } 
   return;  
  }
 FreeMarginAlert = False;  
 // ---------------------------------------------

 if(Type == OP_BUY)
   string S = "BUY";
  else
   S = "SELL"; 
 int ticket=OrderSend(Symbol(), Type, Lots, Price, 3, SL, TP, NULL, MagicNumber, 0, Arrow);
 if(ticket>0)
   {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
      Print(S, "    : ",OrderOpenPrice());
   }
  else 
   Print("   ", S, ": ",GetLastError()); 
}


  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(!Activate)
    return(0);

    //     
   if(TimeCurrent() - LastOptim > OptimPeriod*60)
     {
      int Res = MessageBox("    "+TimeToStr(LastOptim)+".\n  ?",
                           "", MB_YESNOCANCEL|MB_ICONQUESTION);
      switch(Res)
       {
        case IDYES: Optimization(); break;
        case IDCANCEL: 
         LastOptim = TimeCurrent();
         GlobalVariableSet("LastOptimization", LastOptim);
        break;
        case IDNO: 
         LastOptim += TimeCurrent()-60*(OptimPeriod - Period());
         GlobalVariableSet("LastOptimization", LastOptim);
        break; 
       }                     
     }
   // ---------------------------------------------------  
     
   //    
   double CCI1 = iCCI(Symbol(), 0, CCIPeriod, PRICE_TYPICAL, 1);
   double CCI2 = iCCI(Symbol(), 0, CCIPeriod, PRICE_TYPICAL, 2);
   
   //  
   if(CCI1 < 100 && CCI2 > 100)
    {
     if(IsOwnOrder())
       if(OrderType() == OP_BUY)
         {
          if(!OrderClose(OrderTicket(), Lots, Bid, 3))  
            return(0);
          RefreshRates();  
         } 
        else
         return(0);
     OpenOrder(OP_SELL, Bid, Bid+StopLoss*Point, Bid-TakeProfit*Point, CLR_NONE);
    }
   
   //  
   if(CCI1 > -100 && CCI2 < -100)
    {
     if(IsOwnOrder())
       if(OrderType() == OP_SELL)
         {
          if(!OrderClose(OrderTicket(), Lots, Ask, 3))  
            return(0);
          RefreshRates();  
         } 
        else
         return(0);
     OpenOrder(OP_BUY, Ask, Ask-StopLoss*Point, Ask+TakeProfit*Point, CLR_NONE);
    }
   // -------------------------------------    
//----
   return(0);
  }
//+------------------------------------------------------------------+